import os
import sys
from aqa.math import *
from varmain.primitiv import *
from varmain.custom import *

@activate(Group="Valve", FirstPortEndtypes="XXX", TooltipShort="Kugelhahn", TooltipLong="Kugelhahn mit Schweinkantrieb", LengthUnit="mm", Ports="2")
@group("MainDimensions")
@param(L=LENGTH, TooltipLong="Breite")
@param(D=LENGTH, TooltipLong="Durchmesser")
@param(D1=LENGTH, TooltipLong="Durchmesser")
@param(D3=LENGTH, TooltipLong="Durchmesser")
@param(HG=LENGTH, TooltipLong="Antrieb-Hoehe")
@param(W1=LENGTH, TooltipLong="Antrieb-Winkel")
@param(L5=LENGTH, TooltipLong="Entleerung Abstand")
@param(L6=LENGTH, TooltipLong="Entleerung Abstand")
@param(W5=LENGTH, TooltipLong="Entleerung-Winkel")


def Valve_04(s, L = 1143, D = 610, D1 = 670, D3 = 967.5, HG = 875, W1 = 0.0, L5 = 712, L6 = 255, W5 = -45, **kw):
   
           
    #Body
               
    if D3 > 0.0:
        Body_L1 = D3

    else:
        Body_L1 = L/1.1839
     
    Body_L2=Body_L1*1.5
    Body_L3=L/30
    Body_L4=L-4*Body_L3
    Body_R=40
    Body_L5=D1/2+Body_R
    Body_L6=(Body_L1/2-D1/2)/4
    Body_L7=(Body_L1/2-(2*Body_L6))
    
    
    Body01 = CYLINDER(s, R=D/2, H=L, O=0.0).translate((0, 0, -L/2)) 
    Body02 = ELLIPSOIDSEGMENT(s, RX=Body_L2/2, RY=Body_L1/2, A1=360, A2=0, A3=0, A4=180).rotateY(90) 
    Body03 = CYLINDER(s, R=Body_L1/2, H=Body_L1, O=0.0).translate((0, 0, Body_L1/4-Body_L3))
    Body04 = CYLINDER(s, R=Body_L1/2, H=Body_L1, O=0.0).translate((0, 0, -Body_L1-Body_L1/2+Body_L3+Body_R))

    Body02.subtractFrom(Body03)
    Body03.erase()
    Body02.subtractFrom(Body04)
    Body04.erase()




    Body05 = CYLINDER(s, R=D1/2, H=Body_L4, O=0.0).translate((0, 0, -Body_L4/2))
    Body06 = CONE(s, R1=D/2, R2=D1/2, H=Body_L3, E=0).rotateY(180).translate((0, 0, Body_L4/2+Body_L3))
    Body07 = CONE(s, R1=D/2, R2=D1/2, H=Body_L3, E=0).translate((0, 0, -Body_L4/2-Body_L3))

    Body08 = TORUS(s, R1=Body_L5+Body_L3/3+Body_R/2, R2=Body_R*2).translate((0,0,Body_L1/2-Body_L3))
    Body09 = TORUS(s, R1=Body_L5+Body_L3/3+Body_R/2, R2=Body_R*2).translate((0,0,-Body_L1/2+Body_L3))
    Body02.subtractFrom(Body08)
    Body08.erase()    
    Body02.subtractFrom(Body09)
    Body09.erase()

    Body01.uniteWith(Body02)
    Body02.erase() 

    Body01.uniteWith(Body05)
    Body05.erase() 
    Body01.uniteWith(Body06)
    Body06.erase()     
    Body01.uniteWith(Body07)
    Body07.erase() 


    #Rundung
    
    R_DI = D1
    R_DA = D1+Body_L6
    R_H = Body_L6
    
    Body13 = CYLINDER(s, R=R_DI/2+R_H, H=R_H, O=0.0)
    Body14 = TORUS(s, R1=R_DI/2+R_H, R2=R_H).translate((0,0,R_H))
    Body13.subtractFrom(Body14)
    Body14.erase()
    Body13.translate((0,0,-R_H/7.5))
    
    Body15 = TORUS(s, R1=R_DA/2, R2=R_H).translate((0,0,-R_H))
    Body16 = CYLINDER(s, R=R_DA/2+R_H, H=2*R_H, O=0.0).rotateY(180).translate((0,0,-1*R_H))
    Body17 = CONE(s, R1=R_DA/2+2*R_H, R2=R_DA/2+R_H, H=R_H*1.5, E=0).translate((0,0,-4*R_H))
    
    Body13.uniteWith(Body15)
    Body15.erase()
    Body13.uniteWith(Body16)
    Body16.erase()
    Body13.uniteWith(Body17)
    Body17.erase()    


    Body13.translate((0, 0, Body_L1/4-Body_L3+4*R_H))

    Body01.uniteWith(Body13)
    Body13.erase()

    Body01.rotateY(90)
    

    

    #Schwenkantrieb mit Hand Vorlage Auma
   
    ANT_D = 400
    ANT_D1 = 350
    ANT_D2 = 70
    ANT_H = 31
    ANT_H1 = 213
    ANT_L1 = 115
    ANT_L2 = 370
    ANT_L3 = 105
    ANT_L4 = 160
    ANT_L5 = 75
    ANT_L6 = 80
    ANT_L7 = 145
    ANT_L8 = 45
    ANT_L9 = 20
    ANT_L10 = 70
    ANT_L11 = 50
    ANT_L12 = 490
    ANT_L13 = 45
    ANT_L14 = 160
    ANT_L15 = 130
    ANT_L16 = 20
    ANT_L17 = 121
    ANT_L18 = 160
    ANT_L19 = 170   
   
    #Schwenkantrieb
    ANT_1 = CYLINDER(s, R=ANT_D/2, H=ANT_H, O=0.0)
    ANT_2 = CYLINDER(s, R=ANT_D1/2, H=ANT_H1, O=0.0)
    ANT_3 = BOX(s, L=ANT_L1, W=ANT_L1, H=ANT_L2).translate((0,-ANT_L18,ANT_L17))
    ANT_4 = CYLINDER(s, R=ANT_D2/2, H=ANT_L3, O=0.0).rotateY(90).translate((-ANT_L2/2-ANT_L3,-ANT_L18,ANT_L17))
    ANT_5 = BOX(s, L=ANT_L4, W=ANT_L4, H=ANT_L5).translate((ANT_L2/2+ANT_L5/2,-ANT_L18,ANT_L17))
    ANT_1.uniteWith(ANT_2)
    ANT_2.erase()
    ANT_1.uniteWith(ANT_3)
    ANT_3.erase()
    ANT_1.uniteWith(ANT_4)
    ANT_4.erase()
    ANT_1.uniteWith(ANT_5)
    ANT_5.erase()

    #Handrand
    ANT_6 = BOX(s, L=ANT_L4, W=ANT_L4, H=ANT_L9)
    ANT_7 = ROUNDRECT(s, L=ANT_L6, W=ANT_L6, H=ANT_L8, R2=ANT_L7/2, E=0).rotateY(-90).translate((ANT_L8+ANT_L9/2,0,0))
    ANT_8 = CYLINDER(s, R=ANT_L10/2, H=ANT_L11+ANT_L11/2, O=0.0).rotateY(90).translate((ANT_L8+ANT_L9/2,0,0))
    ANT_9 = CONE(s, R1=ANT_L12/2, R2=ANT_L12/2-ANT_L9, H=ANT_L11, E=0)
    ANT_10 = CYLINDER(s, R=(ANT_L12-2*ANT_L13)/2, H=ANT_L11, O=0.0).translate((0,0,ANT_L11/2))
    ANT_9.subtractFrom(ANT_10)
    ANT_10.erase()
    ANT_11 = CYLINDER(s, R1=ANT_L12/6, R2=ANT_L12/4, H=ANT_L11, O=0.0).translate((ANT_L12/4,0,0))   
    ANT_12 = CYLINDER(s, R1=ANT_L12/6, R2=ANT_L12/4, H=ANT_L11, O=0.0).translate((-ANT_L12/4,0,0))
    ANT_9.subtractFrom(ANT_11)
    ANT_11.erase()
    ANT_9.subtractFrom(ANT_12)
    ANT_12.erase()   
    ANT_13 = CYLINDER(s, R=ANT_L16, H=ANT_L15, O=0.0).translate((0,ANT_L12/2-ANT_L16/2,0))
    ANT_9.uniteWith(ANT_13)
    ANT_13.erase()
    ANT_9.rotateY(90).translate((ANT_L19-ANT_L11-ANT_L9,0,0))

    ANT_6.uniteWith(ANT_7)
    ANT_9.erase()
    ANT_6.uniteWith(ANT_8)
    ANT_9.erase()
    ANT_6.uniteWith(ANT_9)
    ANT_9.erase()
   
    ANT_6.translate((ANT_L2/2+ANT_L5+ANT_L9/2+0.5,-ANT_L18,ANT_L17))
    
    #Schwenkantrieb+Handrad
    
    ANT_1.uniteWith(ANT_6)
    ANT_6.erase()
    
    ANT_1.translate((0,0,HG-ANT_H1)).rotateZ(90)
    ANT_1.rotateZ(W1)
    
    #AnschlussAntrieb
   
    Body17 = CYLINDER(s, R=ANT_D/4, H=HG-ANT_H1, O=0.0)   
    Body18 = CYLINDER(s, R=ANT_D/2, H=ANT_H, O=0.0).translate((0,0,HG-ANT_H1-ANT_H))
    
    
    #Schweissarmatur 2"
    
    KAM_D = 61
    KAM_D1 = 100
    KAM_D2 = 50
    KAM_L = 216
    KAM_L1 = 120
    KAM_L2 = 90
    KAM_L3 = 80
    KAM_L4 = 70
    KAM_L5 = 250
    KAM_L6 = 38
    KAM_L7 = 90
    KAM_L8 = 318
    KAM_H1 = 14
    KAM_H2 = 13
    KAM_H3 = 8
    KAM_H4 = 132
   
    KAM_1 = CYLINDER(s, R=KAM_D/2, H=KAM_L, O=0.0).translate((0,0,-KAM_L/2))
    KAM_2 = BOX(s, L=KAM_L1, W=KAM_H1, H=KAM_L1).translate((0,0,KAM_L3/2+KAM_H1/2))
    KAM_3 = BOX(s, L=KAM_L1, W=KAM_H1, H=KAM_L1).translate((0,0,-KAM_L3/2-KAM_H1/2))   
    KAM_4 = CYLINDER(s, R=KAM_D1/2, H=KAM_L3, O=0.0).translate((0,0,-KAM_L3/2))
    KAM_5 = CYLINDER(s, R=KAM_D2/2, H=KAM_L2, O=0.0).rotateY(90)
    KAM_6 = BOX(s, L=KAM_L4, W=KAM_L4, H=KAM_H2).translate((KAM_L2-KAM_H2/2,0,0))    
    KAM_7 = CYLINDER(s, R=KAM_L4/2, H=KAM_H2, O=0.0).rotateY(90).translate((KAM_L2,0,0))  
    KAM_8 = BOX(s, L=KAM_L6, W=KAM_L5, H=KAM_H3).translate((KAM_H4,0,KAM_L8-KAM_L5/2))
    KAM_9 = BOX(s, L=KAM_L6, W=KAM_L7, H=KAM_H3).rotateY(30).translate((110,0,31))

    KAM_10 = CYLINDER(s, R=KAM_H1/2, H=KAM_L2+4*KAM_H1, O=0.0).translate((KAM_L1/2-KAM_H1,KAM_L1/2-KAM_H1,(KAM_L2+4*KAM_H1)/-2))
    KAM_11 = CYLINDER(s, R=KAM_H1/2, H=KAM_L2+4*KAM_H1, O=0.0).translate(((KAM_L1/2-KAM_H1)*-1,KAM_L1/2-KAM_H1,(KAM_L2+4*KAM_H1)/-2))
    KAM_12 = CYLINDER(s, R=KAM_H1/2, H=KAM_L2+4*KAM_H1, O=0.0).translate((KAM_L1/2-KAM_H1,(KAM_L1/2-KAM_H1)*-1,(KAM_L2+4*KAM_H1)/-2))
    KAM_13 = CYLINDER(s, R=KAM_H1/2, H=KAM_L2+4*KAM_H1, O=0.0).translate(((KAM_L1/2-KAM_H1)*-1,(KAM_L1/2-KAM_H1)*-1,(KAM_L2+4*KAM_H1)/-2))  
   
    KAM_1.uniteWith(KAM_2)
    KAM_2.erase()
    KAM_1.uniteWith(KAM_3)
    KAM_3.erase()
    KAM_1.uniteWith(KAM_4)
    KAM_4.erase()
    KAM_1.uniteWith(KAM_5)
    KAM_5.erase()
    KAM_1.uniteWith(KAM_6)
    KAM_6.erase()
    KAM_1.uniteWith(KAM_7)
    KAM_7.erase()
    KAM_1.uniteWith(KAM_8)
    KAM_8.erase()
    KAM_1.uniteWith(KAM_9)
    KAM_9.erase()
    KAM_1.uniteWith(KAM_10)
    KAM_10.erase()
    KAM_1.uniteWith(KAM_11)
    KAM_11.erase()
    KAM_1.uniteWith(KAM_12)
    KAM_12.erase()
    KAM_1.uniteWith(KAM_13)
    KAM_13.erase()
    
    #Schweissarmatur 2" Position

    KAM_LC = L5
    KAM_LP = L6

    
    Body19 = CYLINDER(s, R=KAM_D/2, H=KAM_L, O=0.0).translate((0,0,-KAM_L))
    KAM_1.uniteWith(Body19)
    Body19.erase()
    
    KAM_1.rotateZ(-90).rotateX(-90)
    KAM_1.translate(((L-KAM_LC)/-2,Body_L1/2+KAM_LP/2,0))
    KAM_1.rotateX(W5)

    #verbinden der Volumen
    Body01.uniteWith(Body17)
    Body17.erase()
    Body01.uniteWith(Body18)
    Body18.erase()
    Body01.uniteWith(KAM_1)
    KAM_1.erase()
    Body01.uniteWith(ANT_1)
    ANT_1.erase()
    
    #port points
    s.setPoint((-L/2, 0.0, 0.0), (-1.0, 0.0, 0.0))
    s.setPoint((L/2, 0.0, 0.0), (+1.0, 0.0, 0.0))
    


#PLANTREGISTERCUSTOMSCRIPTS
#(command "arx" "l" "Pnp3dacpadapter") (testacpscript "Valve04")
#(testacpscript "Valve01")
#(testacpscript1 "Valve01" "PV = 20.0, PH = 10.0")
