import os
import sys
from aqa.math import *
from varmain.primitiv import *
from varmain.custom import *



@activate(Group="Support", FirstPortEndtypes="XXX", TooltipShort="Sikla Lager LD - HV", TooltipLong="Sikla Lager LD - HV", LengthUnit="mm", Ports="1")
@group("MainDimensions")


@param(H=LENGTH, TooltipLong="Einstellhoehe", Ask4Dist=True)
@param(D=LENGTH, TooltipLong="Rohr-Durchmesser")
@param(L2=LENGTH, TooltipLong="Schelle Laenge")
@param(S2=LENGTH, TooltipLong="Schelle Blechdicke")
@param(L1=LENGTH, TooltipLong="Gesamtbreite der Rohrschelle")
@param(B_L1=LENGTH, TooltipLong="Schrauben-Laenge")
@param(B_D1=LENGTH, TooltipLong="Schrauben-Durchmesser")
@param(W=LENGTH, TooltipLong="Winkel der Rohrschellen")




def SiklaLagerLD(s, D = 221, A = 250, B = 100, H = 90, S1 = 8, L1 = 308, L2 = 50, LA = 120, S2 = 8, L3 = 14,  B_L1= 0, B_D1= 0, W = 0, **kw):


    SL1 = 175.0
    if D >= 356:
       SL1 = 215

    SL2 = 5

    SL4 = 105
    if D >= 356:
       SL4 = 145
    SL5 = 23    

    #Abstand der Fussplatten
    AL1=179.06
    if D >= 356:
       AL1 = 219.06
    
    B_L2 = (L1-D-S2)/2/2
       
    if B_D1 <= 0.0:
       B_D1 = (L1-D)/2/3

    if B_L1 <= 0.0:
       B_L1 = L3+2*S2+2*B_D1    
    
    #(Hoehe des Steges gemaess Verstellbereich berechnen)

    Hmin = 88.5
    Hmax = 113.5 


    if H >= 116:
       Hmin = 116

    if H >= 116:
       Hmax = 168.5
  
    if H >= 171:
       Hmin = 171

    if H >= 171:
       Hmax = 223.5     
    
    
    if H > Hmax:
        H = Hmax
    #print('H max ueberschritten, H wird als Hmax ausgefuehrt!')
    elif H < Hmin:
        H = Hmin
    #print('H max ueberschritten, H wird als Hmax ausgefuehrt!')
  
    HG = D/2++H+S1
    



    #Schraubenhoehe
    SKHV1 = 60.5-S1/2

    if H >= 116:
       SKHV1 = 85.5-S1/2

    if H >= 171:
       SKHV1 = 140.5-S1/2   


#HohenverstellungNeu
    HVNEU = D/2+S1/2+H
    
    #Steg------------------------------------------------------------------------------------------------------

    
    STL1 = 50.9118
    STL2 = 28.4121
    STL3 = 33.7259
    STL4 = 32.1278
    STL5 = 33.7259
    STL6 = 28.4097
    STL7 = 50.9120


    STY1 = 6.7975
    STY2 = 2.3766
    STY3 = 4.0356
    STY4 = -7.1565
    STY5 = 4.0356
    STY6 = 2.3766
    STY7 = 6.7975

    
    STX1 = 76.2322
    STX2 = 48.1875
    STX3 = 26.2195
    STX4 = 0
    STX5 = -26.2195
    STX6 = -48.1875
    STX7 = -76.2322


    STB1 = 5

    STBH1 = 69.5
    STBH2 = 66.5
    
    if H >= 113.5:
       STBH2 = 66.5

    if H >= 116:
       STBH2 = 94

    if H >= 171:
       STBH2 = 149

    if H >= 116:
       STBH1 = 97

    if H >= 171:
       STBH1 = 97
    
    
    #Hoehenverstellung
    
    STHV = H-42.75
    STHV_L1 = 10
    STHV_L2 = 43
    STHV_L3 = 43
    STHV_D1 = 10
    STHV_H1 = 50
    STHV_H2 = 25
    STHV_L4 = 5

    #BeinL1-Fest----------------------------------------------------------------------

    fp_01_01 = BOX(s, L=A, W=S1, H=B) #Fussplatte

    
    st_01_o1 = BOX(s, L=STL1, W=STBH2, H=STB1) #Steg1

    st_01_o1.rotateZ(135).translate((STY1,STX1,0.0))
  
    st_01_o2 = BOX(s, L=STL2, W=STBH2, H=STB1).rotateZ(45).translate((STY2,STX2,0.0)) 

    st_01_o3 = BOX(s, L=STL3, W=STBH2, H=STB1).rotateZ(135).translate((STY3,STX3,0.0))
    
    st_01_o4 = BOX(s, L=STL4, W=STBH2, H=STB1).rotateZ(0).translate((STY4,STX4,0.0))

    st_01_o5 = BOX(s, L=STL5, W=STBH2, H=STB1).rotateZ(45).translate((STY5,STX5,0.0))
    
    st_01_o6 = BOX(s, L=STL6, W=STBH2, H=STB1).rotateZ(135).translate((STY6,STX6,0.0))
    
    st_01_o7 = BOX(s, L=STL7, W=STBH2, H=STB1).rotateZ(45).translate((STY7,STX7,0.0))
    
    
    st_01_o1.uniteWith(st_01_o2)
    st_01_o2.erase()
    st_01_o1.uniteWith(st_01_o3)
    st_01_o3.erase()
    st_01_o1.uniteWith(st_01_o4)
    st_01_o4.erase()
    st_01_o1.uniteWith(st_01_o5)
    st_01_o5.erase()
    st_01_o1.uniteWith(st_01_o6)
    st_01_o6.erase()
    st_01_o1.uniteWith(st_01_o7)
    st_01_o7.erase()
    
    st_01_o1.translate((0.0,0.0,STBH2/2+S1/2))

    #Verbindung Fussplatte mit Steg1
    fp_01_01.uniteWith(st_01_o1)
    st_01_o1.erase()
 
    
 
    #SchraubeVerstellung1-----------------------------------------------------------------------------------------------------
    
    SKSV_WM = 19.0
    SKSV_HM = 12.0 
    SKSV_D1 = 12.0
    SKSV_L1 = 30.0



# Schraube1 zeichnen--------

    SKS_01_01 = ELLIPSOIDHEAD(s, R=SKSV_D1).rotateY(180)

# Zylinder   
    SKS_01_02 = CYLINDER(s, R=SKSV_D1/2, H=SKSV_L1, O=0.0)
    SKS_01_01.uniteWith(SKS_01_02)
    SKS_01_02.erase()
    
    
# Schraube drehen
    SKS_01_01.translate((0.0, 0.0, 0.0))    
    
   
    #Mutter1 Verstellung1
    SKSV2_WM = 19.0
    SKSV2_HM = 12.0 
    SKSV2_D1 = 12.0
    SKSV2_L1 = 32.0
    

# Mutter zeichnen
    aWidth2 = SKSV2_WM * sqrt(3.0) / 3.0
    
    MUT_01_01 = BOX(s, L=SKSV2_WM, W=SKSV2_HM, H=aWidth2)   
    MUT_01_02 = BOX(s, L=SKSV2_WM, W=SKSV2_HM, H=aWidth2).rotateZ(60.0)
    MUT_01_03 = BOX(s, L=SKSV2_WM, W=SKSV2_HM, H=aWidth2).rotateZ(-60.0)
    MUT_01_01.uniteWith(MUT_01_02)
    MUT_01_02.erase()
    MUT_01_01.uniteWith(MUT_01_03)
    MUT_01_03.erase()

# Radius Sphere ( Kantenbruch )
    So1R2 = sqrt((SKSV2_HM/2)**2 + (SKSV2_WM/2)**2)
    MUT_01_04 = HALFSPHERE(s, R=So1R2 )
    MUT_01_05 = HALFSPHERE(s, R=So1R2 ).rotateX(180)
    MUT_01_04.uniteWith(MUT_01_05)
    MUT_01_05.erase()
    MUT_01_01.intersectWith(MUT_01_04)
    MUT_01_04.erase()
    
    
# Mutter drehen
    #MUT_01_01.rotateY(90)
    MUT_01_01.translate((0.0, 0.0, 16))
# Mutter mit Schaube verbinden    
    SKS_01_01.uniteWith(MUT_01_01)
    MUT_01_01.erase()
    

    
# Schraube+Mutter verschieben
    SKS_01_01.rotateY(90).rotateZ(135)
    SKS_01_01.translate((-1.3612+16.9975, 39.4623+35.0646,  SKHV1))

# verbinden mit Steg und Fussplatte
    fp_01_01.uniteWith(SKS_01_01)
    SKS_01_01.erase()


# Schraube2 zeichnen--------

    SKS_02_01 = ELLIPSOIDHEAD(s, R=SKSV_D1).rotateY(180)

# Zylinder   
    SKS_02_02 = CYLINDER(s, R=SKSV_D1/2, H=SKSV_L1, O=0.0)
    SKS_02_01.uniteWith(SKS_02_02)
    SKS_02_02.erase()
    
    
# Schraube drehen
    SKS_02_01.translate((0.0, 0.0, 0.0))    


    SKSV2_WM = 19.0
    SKSV2_HM = 12.0 
    SKSV2_D1 = 12.0
    SKSV2_L1 = 32.0
    

# Mutter zeichnen
    aWidth2 = SKSV2_WM * sqrt(3.0) / 3.0
    
    MUT_02_01 = BOX(s, L=SKSV2_WM, W=SKSV2_HM, H=aWidth2)   
    MUT_02_02 = BOX(s, L=SKSV2_WM, W=SKSV2_HM, H=aWidth2).rotateZ(60.0)
    MUT_02_03 = BOX(s, L=SKSV2_WM, W=SKSV2_HM, H=aWidth2).rotateZ(-60.0)
    MUT_02_01.uniteWith(MUT_02_02)
    MUT_02_02.erase()
    MUT_02_01.uniteWith(MUT_02_03)
    MUT_02_03.erase()

# Radius Sphere ( Kantenbruch )
    So1R2 = sqrt((SKSV2_HM/2)**2 + (SKSV2_WM/2)**2)
    MUT_02_04 = HALFSPHERE(s, R=So1R2 )
    MUT_02_05 = HALFSPHERE(s, R=So1R2 ).rotateX(180)
    MUT_02_04.uniteWith(MUT_02_05)
    MUT_02_05.erase()
    MUT_02_01.intersectWith(MUT_02_04)
    MUT_02_04.erase()
    
    
# Mutter drehen
    #MUT_02_01.rotateY(90)
    MUT_02_01.translate((0.0, 0.0, 16))
# Mutter mit Schaube verbinden    
    SKS_02_01.uniteWith(MUT_02_01)
    MUT_02_01.erase()
    

    
# Schraube+Mutter verschieben
    SKS_02_01.rotateY(90).rotateZ(225)
    SKS_02_01.translate((-1.3612+16.9975, -39.4623-35.0646, SKHV1))

# verbinden mit Steg und Fussplatte
    fp_01_01.uniteWith(SKS_02_01)
    SKS_02_01.erase()


# Fuss Links verschieben
    fp_01_01.translate((-AL1/2, 0.0, -HVNEU))

#xxxxxxxxxxxxx BeinL1 -------------------------------------------------------------------

    #BeinR1-Fest----------------------------------------------------------------------

    fp_02_01 = BOX(s, L=A, W=S1, H=B) #Fussplatte

    
    st_02_o1 = BOX(s, L=STL1, W=STBH2, H=STB1) #Steg1

    st_02_o1.rotateZ(135).translate((STY1,STX1,0.0))
  
    st_02_o2 = BOX(s, L=STL2, W=STBH2, H=STB1).rotateZ(45).translate((STY2,STX2,0.0)) 

    st_02_o3 = BOX(s, L=STL3, W=STBH2, H=STB1).rotateZ(135).translate((STY3,STX3,0.0))
    
    st_02_o4 = BOX(s, L=STL4, W=STBH2, H=STB1).rotateZ(0).translate((STY4,STX4,0.0))

    st_02_o5 = BOX(s, L=STL5, W=STBH2, H=STB1).rotateZ(45).translate((STY5,STX5,0.0))
    
    st_02_o6 = BOX(s, L=STL6, W=STBH2, H=STB1).rotateZ(135).translate((STY6,STX6,0.0))
    
    st_02_o7 = BOX(s, L=STL7, W=STBH2, H=STB1).rotateZ(45).translate((STY7,STX7,0.0))
    
    
    st_02_o1.uniteWith(st_02_o2)
    st_02_o2.erase()
    st_02_o1.uniteWith(st_02_o3)
    st_02_o3.erase()
    st_02_o1.uniteWith(st_02_o4)
    st_02_o4.erase()
    st_02_o1.uniteWith(st_02_o5)
    st_02_o5.erase()
    st_02_o1.uniteWith(st_02_o6)
    st_02_o6.erase()
    st_02_o1.uniteWith(st_02_o7)
    st_02_o7.erase()
    
    st_02_o1.translate((0.0,0.0,STBH2/2+S1/2))

    #Verbindung Fussplatte mit Steg1
    fp_02_01.uniteWith(st_02_o1)
    st_02_o1.erase()
 
    
 
    #SchraubeVerstellung1
    
    SKSV_WM = 19.0
    SKSV_HM = 12.0 
    SKSV_D1 = 12.0
    SKSV_L1 = 30.0



# Schraube1 zeichnen--------

    SKS_02_01 = ELLIPSOIDHEAD(s, R=SKSV_D1).rotateY(180)

# Zylinder   
    SKS_02_02 = CYLINDER(s, R=SKSV_D1/2, H=SKSV_L1, O=0.0)
    SKS_02_01.uniteWith(SKS_02_02)
    SKS_02_02.erase()
    
    
# Schraube drehen
    SKS_02_01.translate((0.0, 0.0, 0.0))    
    
   
    #Mutter1 Verstellung1
    SKSV2_WM = 19.0
    SKSV2_HM = 12.0 
    SKSV2_D1 = 12.0
    SKSV2_L1 = 32.0
    

# Mutter zeichnen
    aWidth2 = SKSV2_WM * sqrt(3.0) / 3.0
    
    MUT_02_01 = BOX(s, L=SKSV2_WM, W=SKSV2_HM, H=aWidth2)   
    MUT_02_02 = BOX(s, L=SKSV2_WM, W=SKSV2_HM, H=aWidth2).rotateZ(60.0)
    MUT_02_03 = BOX(s, L=SKSV2_WM, W=SKSV2_HM, H=aWidth2).rotateZ(-60.0)
    MUT_02_01.uniteWith(MUT_02_02)
    MUT_02_02.erase()
    MUT_02_01.uniteWith(MUT_02_03)
    MUT_02_03.erase()

# Radius Sphere ( Kantenbruch )
    So1R2 = sqrt((SKSV2_HM/2)**2 + (SKSV2_WM/2)**2)
    MUT_02_04 = HALFSPHERE(s, R=So1R2 )
    MUT_02_05 = HALFSPHERE(s, R=So1R2 ).rotateX(180)
    MUT_02_04.uniteWith(MUT_02_05)
    MUT_02_05.erase()
    MUT_02_01.intersectWith(MUT_02_04)
    MUT_02_04.erase()
    
    
# Mutter drehen
    #MUT_02_01.rotateY(90)
    MUT_02_01.translate((0.0, 0.0, 16))
# Mutter mit Schaube verbinden    
    SKS_02_01.uniteWith(MUT_02_01)
    MUT_02_01.erase()
    

    
# Schraube+Mutter verschieben
    SKS_02_01.rotateY(90).rotateZ(135)
    SKS_02_01.translate((-1.3612+16.9975, 39.4623+35.0646,  SKHV1))

# verbinden mit Steg und Fussplatte
    fp_02_01.uniteWith(SKS_02_01)
    SKS_02_01.erase()


# Schraube2 zeichnen--------

    SKS_03_01 = ELLIPSOIDHEAD(s, R=SKSV_D1).rotateY(180)

# Zylinder   
    SKS_03_02 = CYLINDER(s, R=SKSV_D1/2, H=SKSV_L1, O=0.0)
    SKS_03_01.uniteWith(SKS_03_02)
    SKS_03_02.erase()
    
    
# Schraube drehen
    SKS_03_01.translate((0.0, 0.0, 0.0))    


    SKSV2_WM = 19.0
    SKSV2_HM = 12.0 
    SKSV2_D1 = 12.0
    SKSV2_L1 = 32.0
    

# Mutter zeichnen
    aWidth2 = SKSV2_WM * sqrt(3.0) / 3.0
    
    MUT_03_01 = BOX(s, L=SKSV2_WM, W=SKSV2_HM, H=aWidth2)   
    MUT_03_02 = BOX(s, L=SKSV2_WM, W=SKSV2_HM, H=aWidth2).rotateZ(60.0)
    MUT_03_03 = BOX(s, L=SKSV2_WM, W=SKSV2_HM, H=aWidth2).rotateZ(-60.0)
    MUT_03_01.uniteWith(MUT_03_02)
    MUT_03_02.erase()
    MUT_03_01.uniteWith(MUT_03_03)
    MUT_03_03.erase()

# Radius Sphere ( Kantenbruch )
    So1R2 = sqrt((SKSV2_HM/2)**2 + (SKSV2_WM/2)**2)
    MUT_03_04 = HALFSPHERE(s, R=So1R2 )
    MUT_03_05 = HALFSPHERE(s, R=So1R2 ).rotateX(180)
    MUT_03_04.uniteWith(MUT_03_05)
    MUT_03_05.erase()
    MUT_03_01.intersectWith(MUT_03_04)
    MUT_03_04.erase()
    
    
# Mutter drehen
    #MUT_03_01.rotateY(90)
    MUT_03_01.translate((0.0, 0.0, 16))
# Mutter mit Schaube verbinden    
    SKS_03_01.uniteWith(MUT_03_01)
    MUT_03_01.erase()
    

    
# Schraube+Mutter verschieben
    SKS_03_01.rotateY(90).rotateZ(225)
    SKS_03_01.translate((-1.3612+16.9975, -39.4623-35.0646, SKHV1))

# verbinden mit Steg und Fussplatte
    fp_02_01.uniteWith(SKS_03_01)
    SKS_03_01.erase()


# Fuss Rechts verschieben und drehen
    fp_02_01.rotateZ(180).translate((AL1/2, 0.0, -HVNEU))

#xxxxxxxxxxxxx StegR -------------------------------------------------------------------   

    
    #VerstellungL----------------------------------------------------------

    HV_01_o1 = BOX(s, L=STL1, W=STBH1, H=STB1)
    HV_01_o1_1 = BOX(s, L=STHV_L1, W=STHV_L2, H=STHV_L3)
    HV_01_o1.subtractFrom(HV_01_o1_1)
    HV_01_o1_1.erase()
    HV_01_o1.rotateZ(135).translate((STY1,STX1,0.0))
  
    HV_01_o2 = BOX(s, L=STL2, W=STBH1, H=STB1).rotateZ(45).translate((STY2,STX2,0.0)) 

    HV_01_o3 = BOX(s, L=STL3, W=STBH1, H=STB1).rotateZ(135).translate((STY3,STX3,0.0))
    
    HV_01_o4 = BOX(s, L=STL4, W=STBH1, H=STB1).rotateZ(0).translate((STY4,STX4,0.0))

    HV_01_o5 = BOX(s, L=STL5, W=STBH1, H=STB1).rotateZ(45).translate((STY5,STX5,0.0))

    HV_01_o6 = BOX(s, L=STL6, W=STBH1, H=STB1).rotateZ(135).translate((STY6,STX6,0.0))    
    
    HV_01_o7 = BOX(s, L=STL7, W=STBH1, H=STB1)
    HV_01_o7_1 = BOX(s, L=STHV_L1, W=STHV_L2, H=STHV_L3)
    HV_01_o7.subtractFrom(HV_01_o7_1)
    HV_01_o7_1.erase()    
    HV_01_o7.rotateZ(45).translate((STY7,STX7,0.0))
    
    
    HV_01_o1.uniteWith(HV_01_o2)
    HV_01_o2.erase()
    HV_01_o1.uniteWith(HV_01_o3)
    HV_01_o3.erase()
    HV_01_o1.uniteWith(HV_01_o4)
    HV_01_o4.erase()
    HV_01_o1.uniteWith(HV_01_o5)
    HV_01_o4.erase()
    HV_01_o1.uniteWith(HV_01_o6)
    HV_01_o4.erase()
    HV_01_o1.uniteWith(HV_01_o7)
    HV_01_o4.erase()    


    HV_01_o1.translate((7.0710,0,0.0))

# Hohenverstellung Links verschieben




    HVA_01=D/2+STBH1/2+8


    if H >= 116:
       HVA_01 = D/2+STBH1/2+8

    if H >= 171:
       HVA_01 = D/2+STBH1/2+5.5 


    HV_01_o1.translate((-AL1/2, 0.0, -HVA_01))
    
     #VerstellungR----------------------------------------------------------

    HV_02_o1 = BOX(s, L=STL1, W=STBH1, H=STB1)
    HV_02_o1_1 = BOX(s, L=STHV_L1, W=STHV_L2, H=STHV_L3)
    HV_02_o1.subtractFrom(HV_02_o1_1)
    HV_02_o1_1.erase()
    HV_02_o1.rotateZ(135).translate((STY1,STX1,0.0))
  
    HV_02_o2 = BOX(s, L=STL2, W=STBH1, H=STB1).rotateZ(45).translate((STY2,STX2,0.0)) 

    HV_02_o3 = BOX(s, L=STL3, W=STBH1, H=STB1).rotateZ(135).translate((STY3,STX3,0.0))
    
    HV_02_o4 = BOX(s, L=STL4, W=STBH1, H=STB1).rotateZ(0).translate((STY4,STX4,0.0))

    HV_02_o5 = BOX(s, L=STL5, W=STBH1, H=STB1).rotateZ(45).translate((STY5,STX5,0.0))

    HV_02_o6 = BOX(s, L=STL6, W=STBH1, H=STB1).rotateZ(135).translate((STY6,STX6,0.0))    
    
    HV_02_o7 = BOX(s, L=STL7, W=STBH1, H=STB1)
    HV_02_o7_1 = BOX(s, L=STHV_L1, W=STHV_L2, H=STHV_L3)
    HV_02_o7.subtractFrom(HV_02_o7_1)
    HV_02_o7_1.erase()    
    HV_02_o7.rotateZ(45).translate((STY7,STX7,0.0))
    
    
    HV_02_o1.uniteWith(HV_02_o2)
    HV_02_o2.erase()
    HV_02_o1.uniteWith(HV_02_o3)
    HV_02_o3.erase()
    HV_02_o1.uniteWith(HV_02_o4)
    HV_02_o4.erase()
    HV_02_o1.uniteWith(HV_02_o5)
    HV_02_o4.erase()
    HV_02_o1.uniteWith(HV_02_o6)
    HV_02_o4.erase()
    HV_02_o1.uniteWith(HV_02_o7)
    HV_02_o4.erase()    


    HV_02_o1.translate((7.0710,0,0.0))   
    
# Fuss Rechts verschieben und drehen

    HV_02_o1.rotateZ(180).translate((AL1/2, 0.0, -HVA_01))    
    

    




    #Schelle1------------------------------------------------------------------------------------------------------
        
    o10 = CYLINDER(s, R=D/2+S2,  H=L2, O=0.0).rotateX(-90).translate((0.0, -L2/2, 0.0)) 
    o11 = BOX(s, L=L2, W=2*S2+L3, H=L1)
    o12 = BOX(s, L=L2, W=L3, H=L1)
     
    o13 = CYLINDER(s, R=D/2,  H=L2, O=0.0).rotateX(-90).translate((0.0, -L2/2, 0.0)) 

    o10.uniteWith(o11)
    o11.erase()    
    o10.subtractFrom(o12)
    o12.erase()
    o10.subtractFrom(o13)
    o13.erase()  
    
    #Schraube1
    
    SKS_WM = 19.0
    SKS_HM = B_D1 
    SKS_D1 = B_D1
    SKS_L1 = B_L1



# Schraube zeichnen
    aWidth = SKS_WM * sqrt(3.0) / 3.0
    
    SKS_o1 = BOX(s, L=SKS_WM, W=SKS_HM, H=aWidth)
    SKS_o2 = BOX(s, L=SKS_WM, W=SKS_HM, H=aWidth).rotateZ(60.0)
    SKS_o3 = BOX(s, L=SKS_WM, W=SKS_HM, H=aWidth).rotateZ(-60.0)
    SKS_o1.uniteWith(SKS_o2)
    SKS_o2.erase()
    SKS_o1.uniteWith(SKS_o3)
    SKS_o3.erase()
  
# Radius Sphere ( Kantenbruch )
    So1R = sqrt((SKS_HM/2)**2 + (SKS_WM/2)**2)
    
    SKS_So1 = HALFSPHERE(s, R=So1R )
    SKS_So2 = HALFSPHERE(s, R=So1R ).rotateX(180)
    SKS_So1.uniteWith(SKS_So2)
    SKS_So2.erase()
    SKS_o1.intersectWith(SKS_So1)
    SKS_So1.erase()
    
# Zylinder   
    SKS_oC1 = CYLINDER(s, R=SKS_D1/2, H=SKS_L1, O=0.0).translate((0.0, 0.0, SKS_HM/2))
    SKS_o1.uniteWith(SKS_oC1)
    SKS_oC1.erase()
# Fasen

    CoH = SKS_D1 * 0.025
    CoR1 = SKS_D1/2 + CoH
    CoR2 = SKS_D1/2

# Schraube drehen
    SKS_o1.rotateY(180)
    SKS_o1.translate((0.0, 0.0, (S2+L3/2+SKS_HM/2)))    
    #Schraube1 Ende
    
    #Mutter1
    SKS2_WM = 19.0
    SKS2_HM = B_D1 
    SKS2_D1 = B_D1
    SKS2_L1 = B_L1
    

# Mutter zeichnen
    #aWidth = SKS_WM * sqrt(3.0) / 3.0
    
    SKS2_o1 = BOX(s, L=SKS2_WM, W=SKS2_HM, H=aWidth)
    SKS2_o2 = BOX(s, L=SKS2_WM, W=SKS2_HM, H=aWidth).rotateZ(60.0)
    SKS2_o3 = BOX(s, L=SKS2_WM, W=SKS2_HM, H=aWidth).rotateZ(-60.0)
    SKS2_o1.uniteWith(SKS2_o2)
    SKS2_o2.erase()
    SKS2_o1.uniteWith(SKS2_o3)
    SKS2_o3.erase()
  
# Radius Sphere ( Kantenbruch )
    #So1R = sqrt((SKS2_HM/2)**2 + (SKS2_WM/2)**2)
    
    SKS2_So1 = HALFSPHERE(s, R=So1R )
    SKS2_So2 = HALFSPHERE(s, R=So1R ).rotateX(180)
    SKS2_So1.uniteWith(SKS2_So2)
    SKS2_So2.erase()
    SKS2_o1.intersectWith(SKS2_So1)
    SKS2_So1.erase()
    

# Fasen
    #CoH = SKS2_D1 * 0.025
    #CoR1 = SKS2_D1/2 + CoH
    #CoR2 = SKS2_D1/2
    
    SKS2_Con1 = CONE(s, R1=CoR1, R2=CoR2, H=CoH, E=0.0).translate((0.0, 0.0, -SKS2_HM/2))
    SKS2_o1.subtractFrom(SKS2_Con1)
    SKS2_Con1.erase()
    SKS2_Con2 = CONE(s, R1=CoR1, R2=CoR2, H=CoH, E=0.0).rotateX(180).translate((0.0, 0.0, SKS2_HM/2))
    SKS2_o1.subtractFrom(SKS2_Con2)
    SKS2_Con2.erase()
    
# Mutter drehen
    #SKS2_o1.rotateY(90)
    SKS2_o1.translate((0.0, 0.0, -(S2+L3/2+SKS2_HM/2)))
    
    SKS_o1.uniteWith(SKS2_o1)
    SKS2_o1.erase()
    
# Schraube+Mutter verschieben
    SKS_o1.translate((L1/2-B_L2, 0.0, 0.0))
    
    #Mutter1 Ende 
    
    #Schraube2
    
    SKS3_WM = 19.0
    SKS3_HM = B_D1 
    SKS3_D1 = B_D1
    SKS3_L1 = B_L1



# Schraube zeichnen
    aWidth = SKS3_WM * sqrt(3.0) / 3.0
    
    SKS3_o1 = BOX(s, L=SKS3_WM, W=SKS3_HM, H=aWidth)
    SKS3_o2 = BOX(s, L=SKS3_WM, W=SKS3_HM, H=aWidth).rotateZ(60.0)
    SKS3_o3 = BOX(s, L=SKS3_WM, W=SKS3_HM, H=aWidth).rotateZ(-60.0)
    SKS3_o1.uniteWith(SKS3_o2)
    SKS3_o2.erase()
    SKS3_o1.uniteWith(SKS3_o3)
    SKS3_o3.erase()
  
# Radius Sphere ( Kantenbruch )
    So1R = sqrt((SKS3_HM/2)**2 + (SKS3_WM/2)**2)
    
    SKS3_So1 = HALFSPHERE(s, R=So1R )
    SKS3_So2 = HALFSPHERE(s, R=So1R ).rotateX(180)
    SKS3_So1.uniteWith(SKS3_So2)
    SKS3_So2.erase()
    SKS3_o1.intersectWith(SKS3_So1)
    SKS3_So1.erase()
    
# Zylinder   
    SKS3_oC1 = CYLINDER(s, R=SKS3_D1/2, H=SKS3_L1, O=0.0).translate((0.0, 0.0, SKS3_HM/2))
    SKS3_o1.uniteWith(SKS3_oC1)
    SKS3_oC1.erase()
# Fasen
    CoH = SKS3_D1 * 0.025
    CoR1 = SKS3_D1/2 + CoH
    CoR2 = SKS3_D1/2

# Schraube drehen
    SKS3_o1.rotateY(180)
    SKS3_o1.translate((0.0, 0.0, (S2+L3/2+SKS3_HM/2)))    
    #Schraube2 Ende
    
    #Mutter2
    SKS4_WM = 19.0
    SKS4_HM = B_D1 
    SKS4_D1 = B_D1
    SKS4_L1 = B_L1
    

# Mutter zeichnen
    #aWidth = SKS_WM * sqrt(3.0) / 3.0
    
    SKS4_o1 = BOX(s, L=SKS4_WM, W=SKS4_HM, H=aWidth)
    SKS4_o2 = BOX(s, L=SKS4_WM, W=SKS4_HM, H=aWidth).rotateZ(60.0)
    SKS4_o3 = BOX(s, L=SKS4_WM, W=SKS4_HM, H=aWidth).rotateZ(-60.0)
    SKS4_o1.uniteWith(SKS4_o2)
    SKS4_o2.erase()
    SKS4_o1.uniteWith(SKS4_o3)
    SKS4_o3.erase()
  
# Radius Sphere ( Kantenbruch )
    #So1R = sqrt((SKS4_HM/2)**2 + (SKS4_WM/2)**2)
    
    SKS4_So1 = HALFSPHERE(s, R=So1R )
    SKS4_So2 = HALFSPHERE(s, R=So1R ).rotateX(180)
    SKS4_So1.uniteWith(SKS4_So2)
    SKS4_So2.erase()
    SKS4_o1.intersectWith(SKS4_So1)
    SKS4_So1.erase()
    

# Fasen
    #CoH = SKS4_D1 * 0.025
    #CoR1 = SKS4_D1/2 + CoH
    #CoR2 = SKS4_D1/2
    
    SKS4_Con1 = CONE(s, R1=CoR1, R2=CoR2, H=CoH, E=0.0).translate((0.0, 0.0, -SKS4_HM/2))
    SKS4_o1.subtractFrom(SKS4_Con1)
    SKS4_Con1.erase()
    SKS4_Con2 = CONE(s, R1=CoR1, R2=CoR2, H=CoH, E=0.0).rotateX(180).translate((0.0, 0.0, SKS4_HM/2))
    SKS4_o1.subtractFrom(SKS4_Con2)
    SKS4_Con2.erase()
    
# Mutter drehen
    #SKS4_o1.rotateY(90)
    SKS4_o1.translate((0.0, 0.0, -(S2+L3/2+SKS4_HM/2)))
    
    SKS3_o1.uniteWith(SKS4_o1)
    SKS4_o1.erase()
#Schraube+Mutter verschieben
    
    SKS3_o1.translate((-(L1/2-B_L2), 0.0, 0.0))
    
    #Mutter2 Ende
    
    #o14 = CYLINDER(s, R=B_D1/2,  H=B_L1, O=0.0).translate((L1/2-B_L2, 0.0, -B_L1/2))
    #o15 = CYLINDER(s, R=B_D1/2,  H=B_L1, O=0.0).translate((-1*(L1/2-B_L2), 0.0, -B_L1/2))
    
    o10.uniteWith(SKS_o1)
    SKS_o1.erase()
    o10.uniteWith(SKS3_o1)
    SKS3_o1.erase()


    
    #Schelle2------------------------------------------------------------------------------------------------------
        
    o20 = CYLINDER(s, R=D/2+S2,  H=L2, O=0.0).rotateX(-90).translate((0.0, -L2/2, 0.0)) 
    o21 = BOX(s, L=L2, W=2*S2+L3, H=L1)
    o22 = BOX(s, L=L2, W=L3, H=L1)
     
    o23 = CYLINDER(s, R=D/2,  H=L2, O=0.0).rotateX(-90).translate((0.0, -L2/2, 0.0)) 

    o20.uniteWith(o21)
    o21.erase()    
    o20.subtractFrom(o22)
    o22.erase()
    o20.subtractFrom(o23)
    o23.erase()  
    
    #Schraube1
    
    SKS_02_WM = 19.0
    SKS_02_HM = B_D1 
    SKS_02_D1 = B_D1
    SKS_02_L1 = B_L1



# Schraube zeichnen

    
    SKS_02_o1 = BOX(s, L=SKS_02_WM, W=SKS_02_HM, H=aWidth)
    SKS_02_o2 = BOX(s, L=SKS_02_WM, W=SKS_02_HM, H=aWidth).rotateZ(60.0)
    SKS_02_o3 = BOX(s, L=SKS_02_WM, W=SKS_02_HM, H=aWidth).rotateZ(-60.0)
    SKS_02_o1.uniteWith(SKS_02_o2)
    SKS_02_o2.erase()
    SKS_02_o1.uniteWith(SKS_02_o3)
    SKS_02_o3.erase()
  
# Radius Sphere ( Kantenbruch )
    So1R = sqrt((SKS_02_HM/2)**2 + (SKS_02_WM/2)**2)
    
    SKS_02_So1 = HALFSPHERE(s, R=So1R )
    SKS_02_So2 = HALFSPHERE(s, R=So1R ).rotateX(180)
    SKS_02_So1.uniteWith(SKS_02_So2)
    SKS_02_So2.erase()
    SKS_02_o1.intersectWith(SKS_02_So1)
    SKS_02_So1.erase()
    
# Zylinder   
    SKS_02_oC1 = CYLINDER(s, R=SKS_02_D1/2, H=SKS_02_L1, O=0.0).translate((0.0, 0.0, SKS_02_HM/2))
    SKS_02_o1.uniteWith(SKS_02_oC1)
    SKS_02_oC1.erase()
# Fasen

    CoH = SKS_02_D1 * 0.025
    CoR1 = SKS_02_D1/2 + CoH
    CoR2 = SKS_02_D1/2

# Schraube drehen
    SKS_02_o1.rotateY(180)
    SKS_02_o1.translate((0.0, 0.0, (S2+L3/2+SKS_02_HM/2)))    
    #Schraube1 Ende
    
    #Mutter1
    SKS_022_WM = 19.0
    SKS_022_HM = B_D1 
    SKS_022_D1 = B_D1
    SKS_022_L1 = B_L1
    

# Mutter zeichnen
    #aWidth = SKS_02_WM * sqrt(3.0) / 3.0
    
    SKS_022_o1 = BOX(s, L=SKS_022_WM, W=SKS_022_HM, H=aWidth)
    SKS_022_o2 = BOX(s, L=SKS_022_WM, W=SKS_022_HM, H=aWidth).rotateZ(60.0)
    SKS_022_o3 = BOX(s, L=SKS_022_WM, W=SKS_022_HM, H=aWidth).rotateZ(-60.0)
    SKS_022_o1.uniteWith(SKS_022_o2)
    SKS_022_o2.erase()
    SKS_022_o1.uniteWith(SKS_022_o3)
    SKS_022_o3.erase()
  
# Radius Sphere ( Kantenbruch )
    #So1R = sqrt((SKS_022_HM/2)**2 + (SKS_022_WM/2)**2)
    
    SKS_022_So1 = HALFSPHERE(s, R=So1R )
    SKS_022_So2 = HALFSPHERE(s, R=So1R ).rotateX(180)
    SKS_022_So1.uniteWith(SKS_022_So2)
    SKS_022_So2.erase()
    SKS_022_o1.intersectWith(SKS_022_So1)
    SKS_022_So1.erase()
    

# Fasen
    #CoH = SKS_022_D1 * 0.025
    #CoR1 = SKS_022_D1/2 + CoH
    #CoR2 = SKS_022_D1/2
    
    SKS_022_Con1 = CONE(s, R1=CoR1, R2=CoR2, H=CoH, E=0.0).translate((0.0, 0.0, -SKS_022_HM/2))
    SKS_022_o1.subtractFrom(SKS_022_Con1)
    SKS_022_Con1.erase()
    SKS_022_Con2 = CONE(s, R1=CoR1, R2=CoR2, H=CoH, E=0.0).rotateX(180).translate((0.0, 0.0, SKS_022_HM/2))
    SKS_022_o1.subtractFrom(SKS_022_Con2)
    SKS_022_Con2.erase()
    
# Mutter drehen
    #SKS_022_o1.rotateY(90)
    SKS_022_o1.translate((0.0, 0.0, -(S2+L3/2+SKS_022_HM/2)))
    
    SKS_02_o1.uniteWith(SKS_022_o1)
    SKS_022_o1.erase()
    
# Schraube+Mutter verschieben
    SKS_02_o1.translate((L1/2-B_L2, 0.0, 0.0))
    
    #Mutter1 Ende
    
    #Schraube2
    
    SKS_023_WM = 19.0
    SKS_023_HM = B_D1 
    SKS_023_D1 = B_D1
    SKS_023_L1 = B_L1



# Schraube zeichnen

    
    SKS_023_o1 = BOX(s, L=SKS_023_WM, W=SKS_023_HM, H=aWidth)
    SKS_023_o2 = BOX(s, L=SKS_023_WM, W=SKS_023_HM, H=aWidth).rotateZ(60.0)
    SKS_023_o3 = BOX(s, L=SKS_023_WM, W=SKS_023_HM, H=aWidth).rotateZ(-60.0)
    SKS_023_o1.uniteWith(SKS_023_o2)
    SKS_023_o2.erase()
    SKS_023_o1.uniteWith(SKS_023_o3)
    SKS_023_o3.erase()
  
# Radius Sphere ( Kantenbruch )

    
    SKS_023_So1 = HALFSPHERE(s, R=So1R )
    SKS_023_So2 = HALFSPHERE(s, R=So1R ).rotateX(180)
    SKS_023_So1.uniteWith(SKS_023_So2)
    SKS_023_So2.erase()
    SKS_023_o1.intersectWith(SKS_023_So1)
    SKS_023_So1.erase()
    
# Zylinder   
    SKS_023_oC1 = CYLINDER(s, R=SKS_023_D1/2, H=SKS_023_L1, O=0.0).translate((0.0, 0.0, SKS_023_HM/2))
    SKS_023_o1.uniteWith(SKS_023_oC1)
    SKS_023_oC1.erase()
# Fasen


# Schraube drehen
    SKS_023_o1.rotateY(180)
    SKS_023_o1.translate((0.0, 0.0, (S2+L3/2+SKS_023_HM/2)))    
    #Schraube2 Ende
    
    #Mutter2
    SKS_024_WM = 19.0
    SKS_024_HM = B_D1 
    SKS_024_D1 = B_D1
    SKS_024_L1 = B_L1
    

# Mutter zeichnen
    #aWidth = SKS_02_WM * sqrt(3.0) / 3.0
    
    SKS_024_o1 = BOX(s, L=SKS_024_WM, W=SKS_024_HM, H=aWidth)
    SKS_024_o2 = BOX(s, L=SKS_024_WM, W=SKS_024_HM, H=aWidth).rotateZ(60.0)
    SKS_024_o3 = BOX(s, L=SKS_024_WM, W=SKS_024_HM, H=aWidth).rotateZ(-60.0)
    SKS_024_o1.uniteWith(SKS_024_o2)
    SKS_024_o2.erase()
    SKS_024_o1.uniteWith(SKS_024_o3)
    SKS_024_o3.erase()
  
# Radius Sphere ( Kantenbruch )
    #So1R = sqrt((SKS_024_HM/2)**2 + (SKS_024_WM/2)**2)
    
    SKS_024_So1 = HALFSPHERE(s, R=So1R )
    SKS_024_So2 = HALFSPHERE(s, R=So1R ).rotateX(180)
    SKS_024_So1.uniteWith(SKS_024_So2)
    SKS_024_So2.erase()
    SKS_024_o1.intersectWith(SKS_024_So1)
    SKS_024_So1.erase()
    

# Fasen
    #CoH = SKS_024_D1 * 0.025
    #CoR1 = SKS_024_D1/2 + CoH
    #CoR2 = SKS_024_D1/2
    
    SKS_024_Con1 = CONE(s, R1=CoR1, R2=CoR2, H=CoH, E=0.0).translate((0.0, 0.0, -SKS_024_HM/2))
    SKS_024_o1.subtractFrom(SKS_024_Con1)
    SKS_024_Con1.erase()
    SKS_024_Con2 = CONE(s, R1=CoR1, R2=CoR2, H=CoH, E=0.0).rotateX(180).translate((0.0, 0.0, SKS_024_HM/2))
    SKS_024_o1.subtractFrom(SKS_024_Con2)
    SKS_024_Con2.erase()
    
# Mutter drehen

    SKS_024_o1.translate((0.0, 0.0, -(S2+L3/2+SKS_024_HM/2)))
    
    SKS_023_o1.uniteWith(SKS_024_o1)
    SKS_024_o1.erase()
#Schraube+Mutter verschieben
    
    SKS_023_o1.translate((-(L1/2-B_L2), 0.0, 0.0))
    
    #Mutter2 Ende
    

    
    o20.uniteWith(SKS_02_o1)
    SKS_02_o1.erase()
    o20.uniteWith(SKS_023_o1)
    SKS_023_o1.erase()
    
    SA1 = LA/2

# Schelle 1 und 2 verschieben und drehen

    o10.rotateY(W).translate((0.0, SA1, 0))
    o20.rotateY(W).translate((0.0, -SA1, 0))

    
    #Verbindungs Steg1

    SL3=STBH1*2
    SH1=(SL3-SL5)/2

    SL6=14.1421
    SL7=46.5


    SL8=24.6055
    
    if H >= 116:
       SL8= (-2.5263)

    if H >= 171:
       SL8= (-2.5263)    
    
    SD1=10
    SD2=16
    SL9=15
    SL10=SL3/4
    SL11=SL4/2+14.5

    o30 = BOX(s, L=SL2, W=SL3, H=SL1).translate((0.0, 0.0, 0.0))

    o30_03 = CYLINDER(s, R=D/2,  H=A, O=0.0).rotateX(-90).translate((0.0, -D/2, 0))
    o30_04 = BOX(s, L=SL2, W=SL5, H=SL4).translate((0.0, 0.0, -SH1))

    o30.subtractFrom(o30_04)
    o30_04.erase()

    o30_01 = BOX(s, L=SL2, W=SL6, H=SL6).rotateY(45).translate((SL4/2, 0.0, -SL7))
    o30_02 = BOX(s, L=SL2, W=SL6, H=SL6).rotateY(45).translate((-SL4/2, 0.0, -SL7))


    o30.uniteWith(o30_01)
    o30_01.erase()
    o30.uniteWith(o30_02)
    o30_02.erase()

    o30_05 = CYLINDER(s, R=SD1/2,  H=S1, O=0.0).rotateX(-90).translate((0.0, -SD1/2, -SL8))

    o30.subtractFrom(o30_05)
    o30_05.erase()

    o30_06 = CYLINDER(s, R=SD2/2,  H=SL2, O=0.0).rotateX(-90).translate((SL9/2, -SL2/2, 0.0))
    o30_06_01 = CYLINDER(s, R=SD2/2,  H=SL2, O=0.0).rotateX(-90).translate((-SL9/2, -SL2/2, 0.0))
    o30_06_02 = BOX(s, L=SL2, W=SD2, H=SL9).translate((0.0, 0.0, 0.0))    

    o30_06.uniteWith(o30_06_01)
    o30_06_01.erase()
    o30_06.uniteWith(o30_06_02)
    o30_06_02.erase()

    o30_06.translate((SL11, 0.0, -SL10))

    o30.subtractFrom(o30_06)
    o30_06.erase()

    o30_07 = CYLINDER(s, R=SD2/2,  H=SL2, O=0.0).rotateX(-90).translate((SL9/2, -SL2/2, 0.0))
    o30_07_01 = CYLINDER(s, R=SD2/2,  H=SL2, O=0.0).rotateX(-90).translate((-SL9/2, -SL2/2, 0.0))
    o30_07_02 = BOX(s, L=SL2, W=SD2, H=SL9).translate((0.0, 0.0, 0.0))    

    o30_07.uniteWith(o30_07_01)
    o30_07_01.erase()
    o30_07.uniteWith(o30_07_02)
    o30_07_02.erase()

    o30_07.translate((-SL11, 0.0, -SL10))

    o30.subtractFrom(o30_07)
    o30_07.erase()

    
    o30HV= HVA_01-34.7500
    
    if H >= 116:
       o30HV= HVA_01

    if H >= 171:
       o30HV= HVA_01


    o30.translate((0.0, -SA1,-o30HV))

    o30.subtractFrom(o30_03)
    o30_03.erase()



    #Verbindungs Steg2
    o31 = BOX(s, L=SL2, W=SL3, H=SL1).translate((0.0, 0.0, 0.0))

    o31_03 = CYLINDER(s, R=D/2,  H=A, O=0.0).rotateX(-90).translate((0.0, -D/2, 0))
    o31_04 = BOX(s, L=SL2, W=SL5, H=SL4).translate((0.0, 0.0, -SH1))

    o31.subtractFrom(o31_04)
    o31_04.erase()

    o31_01 = BOX(s, L=SL2, W=SL6, H=SL6).rotateY(45).translate((SL4/2, 0.0, -SL7))
    o31_02 = BOX(s, L=SL2, W=SL6, H=SL6).rotateY(45).translate((-SL4/2, 0.0, -SL7))


    o31.uniteWith(o31_01)
    o31_01.erase()
    o31.uniteWith(o31_02)
    o31_02.erase()

    o31_05 = CYLINDER(s, R=SD1/2,  H=S1, O=0.0).rotateX(-90).translate((0.0, -SD1/2, -SL8))

    o31.subtractFrom(o31_05)
    o31_05.erase()

    o31_06 = CYLINDER(s, R=SD2/2,  H=SL2, O=0.0).rotateX(-90).translate((SL9/2, -SL2/2, 0.0))
    o31_06_01 = CYLINDER(s, R=SD2/2,  H=SL2, O=0.0).rotateX(-90).translate((-SL9/2, -SL2/2, 0.0))
    o31_06_02 = BOX(s, L=SL2, W=SD2, H=SL9).translate((0.0, 0.0, 0.0))    

    o31_06.uniteWith(o31_06_01)
    o31_06_01.erase()
    o31_06.uniteWith(o31_06_02)
    o31_06_02.erase()

    o31_06.translate((SL11, 0.0, -SL10))

    o31.subtractFrom(o31_06)
    o31_06.erase()

    o31_07 = CYLINDER(s, R=SD2/2,  H=SL2, O=0.0).rotateX(-90).translate((SL9/2, -SL2/2, 0.0))
    o31_07_01 = CYLINDER(s, R=SD2/2,  H=SL2, O=0.0).rotateX(-90).translate((-SL9/2, -SL2/2, 0.0))
    o31_07_02 = BOX(s, L=SL2, W=SD2, H=SL9).translate((0.0, 0.0, 0.0))    

    o31_07.uniteWith(o31_07_01)
    o31_07_01.erase()
    o31_07.uniteWith(o31_07_02)
    o31_07_02.erase()

    o31_07.translate((-SL11, 0.0, -SL10))

    o31.subtractFrom(o31_07)
    o31_07.erase()

    
    o31HV= HVA_01-34.7500
    
    if H >= 116:
       o31HV= HVA_01

    if H >= 171:
       o31HV= HVA_01


    o31.translate((0.0, SA1,-o31HV))

    o31.subtractFrom(o31_03)
    o31_03.erase()

 
    o10.uniteWith(o20)
    o20.erase()

    o10.uniteWith(o30)
    o30.erase()    
 
    o10.uniteWith(o31)
    o31.erase() 

    o10.uniteWith(HV_02_o1)
    HV_02_o1.erase()

    o10.uniteWith(HV_01_o1)
    HV_01_o1.erase()    
 
    #port points
    s.setPoint((0.0, 0.0, 0.0), (0.0, -1.0, 0.0))
    s.setLinearDimension('H', (0, 0, -HG), (0, 0, -HG))



#(command "arx" "l" "Pnp3dacpadapter") (testacpscript "SiklaLagerLD")
#(command "arx" "l" "Pnp3dacpadapter") (testacpscript1 "LISEGA49_01" "A = 500" "H = 200")

