import os
import sys
from aqa.math import *
from varmain.primitiv import *
from varmain.custom import *

@activate(Group="Valve", FirstPortEndtypes="XXX", TooltipShort="Kompensator", TooltipLong="Kompensator", LengthUnit="mm", Ports="2")
@group("MainDimensions")
@param(L=LENGTH, TooltipLong="Breite")
@param(D=LENGTH, TooltipLong="Durchmesser")
@param(W1=LENGTH, TooltipLong="Durchmesser")
@param(H11=LENGTH, TooltipLong="Durchmesser")
@param(B1=LENGTH, TooltipLong="Gewindetiefe")



def Valve_Kompensator03(s, D = 610, W1 = 1000, H11 = 685, L = 1350, B1 = 70, **kw):
   
   #Kompensator Vorlage Witzenmann Typ LRK/LRN
    
   #Flange
   
   LA1 = (W1+H11)/2
   
   FL1 = CYLINDER(s, R1=H11, R2=H11/2, H=B1, O=0.0).translate((0, 0, L/2-2*B1))
   FL2 = CYLINDER(s, R1=H11, R2=H11/2, H=B1, O=0.0).translate((0, 0, -L/2+B1))
   
   FL3 = BOX(s, L=H11, W=L, H=H11).translate((LA1, 0, 0))
   FL4 = BOX(s, L=H11, W=L, H=H11).translate((-LA1, 0, 0))
   FL5 = BOX(s, L=H11, W=L, H=H11).translate((LA1, 0, 0))
   FL6 = BOX(s, L=H11, W=L, H=H11).translate((-LA1, 0, 0))

   FL1.subtractFrom(FL3)
   FL3.erase()   
   FL1.subtractFrom(FL4)
   FL4.erase()   
   FL2.subtractFrom(FL5)
   FL5.erase()  
   FL2.subtractFrom(FL6)
   FL6.erase()
   
   
   #Body
   
   BOD1 = 10
   BOD2 = D/2
   
   BO1 = CYLINDER(s, R=D/2, H=L, O=0.0).translate((0, 0, -L/2))
   
   BO1.uniteWith(FL1)
   FL1.erase()
   BO1.uniteWith(FL2)
   FL2.erase()   

   BO1_1 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 0))
   BO1_2 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 2*BOD1))   
   BO1_3 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 4*BOD1))
   BO1_4 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 6*BOD1)) 
   BO1_5 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 8*BOD1)) 
   BO1_6 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 10*BOD1)) 
   BO1_7 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 12*BOD1)) 
   BO1_8 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 14*BOD1)) 
   BO1_9 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 16*BOD1)) 
   BO1_10 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 18*BOD1)) 
   BO1_11 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 20*BOD1)) 
   BO1_12 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 22*BOD1)) 
   BO1_13 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 24*BOD1)) 
   BO1_14 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 26*BOD1)) 
   BO1_15 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 28*BOD1)) 
   BO1_16 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 30*BOD1))
   BO1_17 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 32*BOD1))   
   BO1_18 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 34*BOD1))
   BO1_19 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 36*BOD1)) 
   BO1_20 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 38*BOD1)) 
   BO1_21 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 40*BOD1)) 
   BO1_22 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 42*BOD1)) 
   BO1_23 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 44*BOD1)) 
   BO1_24 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 46*BOD1)) 
   BO1_25 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 48*BOD1)) 
   BO1_26 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 50*BOD1)) 
   BO1_27 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 52*BOD1)) 
   BO1_28 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 54*BOD1)) 
   BO1_29 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 56*BOD1)) 
   BO1_30 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, 58*BOD1))
   
   BO1_32 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -2*BOD1))   
   BO1_33 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -4*BOD1))
   BO1_34 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -6*BOD1)) 
   BO1_35 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -8*BOD1)) 
   BO1_36 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -10*BOD1)) 
   BO1_37 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -12*BOD1)) 
   BO1_38 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -14*BOD1)) 
   BO1_39 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -16*BOD1)) 
   BO1_40 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -18*BOD1)) 
   BO1_41 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -20*BOD1)) 
   BO1_42 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -22*BOD1)) 
   BO1_43 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -24*BOD1)) 
   BO1_44 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -26*BOD1)) 
   BO1_45 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -28*BOD1)) 
   BO1_46 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -30*BOD1))
   BO1_47 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -32*BOD1))   
   BO1_48 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -34*BOD1))
   BO1_49 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -36*BOD1)) 
   BO1_50 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -38*BOD1)) 
   BO1_51 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -40*BOD1)) 
   BO1_52 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -42*BOD1)) 
   BO1_53 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -44*BOD1)) 
   BO1_54 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -46*BOD1)) 
   BO1_55 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -48*BOD1)) 
   BO1_56 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -50*BOD1)) 
   BO1_57 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -52*BOD1)) 
   BO1_58 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -54*BOD1)) 
   BO1_59 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -56*BOD1)) 
   BO1_60 = TORUS(s, R1=BOD2, R2=BOD1).translate((0, 0, -58*BOD1))
    
   BO1_1.uniteWith(BO1_2)
   BO1_1.uniteWith(BO1_3)
   BO1_1.uniteWith(BO1_4)
   BO1_1.uniteWith(BO1_5)
   BO1_1.uniteWith(BO1_6)
   BO1_1.uniteWith(BO1_7)
   BO1_1.uniteWith(BO1_8)
   BO1_1.uniteWith(BO1_9)
   BO1_1.uniteWith(BO1_10)
   BO1_1.uniteWith(BO1_11)
   BO1_1.uniteWith(BO1_12)
   BO1_1.uniteWith(BO1_13)
   BO1_1.uniteWith(BO1_14)
   BO1_1.uniteWith(BO1_15)
   BO1_1.uniteWith(BO1_16)
   BO1_1.uniteWith(BO1_17)
   BO1_1.uniteWith(BO1_18)
   BO1_1.uniteWith(BO1_19)
   BO1_1.uniteWith(BO1_20)
   BO1_1.uniteWith(BO1_21)   
   BO1_1.uniteWith(BO1_22)
   BO1_1.uniteWith(BO1_23)
   BO1_1.uniteWith(BO1_24)
   BO1_1.uniteWith(BO1_25)
   BO1_1.uniteWith(BO1_26)
   BO1_1.uniteWith(BO1_27)
   BO1_1.uniteWith(BO1_28)
   BO1_1.uniteWith(BO1_29)
   BO1_1.uniteWith(BO1_30)

   BO1_32.uniteWith(BO1_33)
   BO1_32.uniteWith(BO1_34)
   BO1_32.uniteWith(BO1_35)
   BO1_32.uniteWith(BO1_36)
   BO1_32.uniteWith(BO1_37)
   BO1_32.uniteWith(BO1_38)
   BO1_32.uniteWith(BO1_39)
   BO1_32.uniteWith(BO1_40)
   BO1_32.uniteWith(BO1_41)
   BO1_32.uniteWith(BO1_42) 
   BO1_32.uniteWith(BO1_43)
   BO1_32.uniteWith(BO1_44)
   BO1_32.uniteWith(BO1_45)
   BO1_32.uniteWith(BO1_46)
   BO1_32.uniteWith(BO1_47)
   BO1_32.uniteWith(BO1_48)
   BO1_32.uniteWith(BO1_49)
   BO1_32.uniteWith(BO1_50)
   BO1_32.uniteWith(BO1_51)
   BO1_32.uniteWith(BO1_52)
   BO1_32.uniteWith(BO1_53)
   BO1_32.uniteWith(BO1_54)
   BO1_32.uniteWith(BO1_55)
   BO1_32.uniteWith(BO1_56)
   BO1_32.uniteWith(BO1_57)
   BO1_32.uniteWith(BO1_58)
   BO1_32.uniteWith(BO1_59)
   BO1_32.uniteWith(BO1_60)
   
   BO1_2.erase()
   BO1_3.erase()
   BO1_4.erase()
   BO1_5.erase()
   BO1_6.erase()
   BO1_7.erase()
   BO1_8.erase()
   BO1_9.erase()
   BO1_10.erase()
   BO1_11.erase()
   BO1_12.erase()
   BO1_13.erase()
   BO1_14.erase()
   BO1_15.erase()
   BO1_16.erase()
   BO1_17.erase()
   BO1_18.erase()
   BO1_19.erase()
   BO1_20.erase()
   BO1_21.erase()
   BO1_22.erase()
   BO1_23.erase()
   BO1_24.erase()
   BO1_25.erase()
   BO1_26.erase()
   BO1_27.erase()
   BO1_28.erase()
   BO1_29.erase()
   BO1_30.erase()
   BO1_33.erase()
   BO1_34.erase()
   BO1_35.erase()
   BO1_36.erase()
   BO1_37.erase()
   BO1_38.erase()
   BO1_39.erase()
   BO1_40.erase()
   BO1_41.erase()
   BO1_42.erase()
   BO1_43.erase()
   BO1_44.erase()
   BO1_45.erase()
   BO1_46.erase()
   BO1_47.erase()
   BO1_48.erase()
   BO1_49.erase()
   BO1_50.erase()
   BO1_51.erase()
   BO1_52.erase()
   BO1_53.erase()
   BO1_54.erase()
   BO1_55.erase()
   BO1_56.erase()
   BO1_57.erase()
   BO1_58.erase()
   BO1_59.erase()
   BO1_60.erase()
   
   
   BO2_1 = CYLINDER(s, R=W1, H=L/4, O=0.0).translate((0, 0, -L/8))
   BO2_2 = CYLINDER(s, R=W1, H=L/6, O=0.0).translate((0, 0, L/2-L/6))
   BO2_3 = CYLINDER(s, R=W1, H=L/4, O=0.0).translate((0, 0, -L/8))
   BO2_4 = CYLINDER(s, R=W1, H=L/6, O=0.0).translate((0, 0, -L/2))
   
   BO1_1.subtractFrom(BO2_1)
   BO2_1.erase()
   BO1_1.subtractFrom(BO2_2)
   BO2_2.erase()
   BO1_32.subtractFrom(BO2_3)
   BO2_3.erase()
   BO1_32.subtractFrom(BO2_4) 
   BO2_4.erase()  
   
   BO1.uniteWith(BO1_1)
   BO1_1.erase()
   BO1.uniteWith(BO1_32)
   BO1_32.erase() 
 
   #Verbindung
   
   VER_L = L-B1*5
   VER_B = B1/3   
   VER_H = (W1-D)/2-B1/2
   VER_AB1 = 50/2
      
   VER1 = BOX(s, L=VER_B, W=VER_L, H=VER_H).translate((W1/2-VER_H/2-VER_B, H11/6, 0))
   VER2 = BOX(s, L=VER_B, W=VER_L, H=VER_H).translate((W1/2-VER_H/2-VER_B, -H11/6, 0))
   VER3 = BOX(s, L=VER_B, W=VER_L, H=VER_H).translate(((W1/2-VER_H/2-VER_B)*-1, H11/6, 0)) 
   VER4 = BOX(s, L=VER_B, W=VER_L, H=VER_H).translate(((W1/2-VER_H/2-VER_B)*-1, -H11/6, 0))

   VER5 = BOX(s, L=H11/3, W=VER_H*2+B1/2, H=VER_B).translate((W1/2-VER_H/2-VER_B+VER_B*2, 0, L/2-VER_H))
   VER6 = BOX(s, L=H11/3, W=VER_H*2+B1/2, H=VER_B).translate((W1/2-VER_H/2-VER_B-VER_B*2, 0, L/2-VER_H))
   VER7 = BOX(s, L=H11/3, W=VER_H*2+B1/2, H=VER_B).translate((W1/2-VER_H/2-VER_B+VER_B*2, 0, (L/2-VER_H)*-1))
   VER8 = BOX(s, L=H11/3, W=VER_H*2+B1/2, H=VER_B).translate((W1/2-VER_H/2-VER_B-VER_B*2, 0, (L/2-VER_H)*-1))
   VER9 = BOX(s, L=H11/3, W=VER_H*2+B1/2, H=VER_B).translate(((W1/2-VER_H/2-VER_B+VER_B*2)*-1, 0, L/2-VER_H))
   VER10 = BOX(s, L=H11/3, W=VER_H*2+B1/2, H=VER_B).translate(((W1/2-VER_H/2-VER_B-VER_B*2)*-1, 0, L/2-VER_H))
   VER11 = BOX(s, L=H11/3, W=VER_H*2+B1/2, H=VER_B).translate(((W1/2-VER_H/2-VER_B+VER_B*2)*-1, 0, (L/2-VER_H)*-1))
   VER12 = BOX(s, L=H11/3, W=VER_H*2+B1/2, H=VER_B).translate(((W1/2-VER_H/2-VER_B-VER_B*2)*-1, 0, (L/2-VER_H)*-1))
   
   VER1.uniteWith(VER2)
   VER2.erase()
   VER1.uniteWith(VER3)
   VER3.erase()
   VER1.uniteWith(VER4)
   VER4.erase()
   VER1.uniteWith(VER5)
   VER5.erase()
   VER1.uniteWith(VER6)
   VER6.erase()
   VER1.uniteWith(VER7)
   VER7.erase()
   VER1.uniteWith(VER8)
   VER8.erase()
   VER1.uniteWith(VER9)
   VER9.erase()
   VER1.uniteWith(VER10)
   VER10.erase()
   VER1.uniteWith(VER11)
   VER11.erase()
   VER1.uniteWith(VER12)
   VER12.erase()   
   
   BO1.uniteWith(VER1)
   VER1.erase()
   
   BO1.rotateY(90)
   
   #port points
   s.setPoint((-L/2, 0.0, 0), (-1.0, 0.0, 0.0))
   s.setPoint((L/2, 0.0, 0), (+1.0, 0.0, 0.0))

#PLANTREGISTERCUSTOMSCRIPTS
#(command "arx" "l" "Pnp3dacpadapter") (testacpscript "Valve_Kompensator03")

